<?php

namespace Drupal\registry_codelists\Controller;

use \Drupal\Core\Form\FormStateInterface;

class CodelistsValidator {
  /*
   * check if code of code or codelist exists, it could be only a unique value, check if it is.
   * Prüfen ob dein Titel(dient als Code) bereits in Nutzung ist und es sich dabei nicht um eine
   */  
  function validate(&$form, $form_state) {
    $id = $form_state->getFormObject()->getEntity()->id();
    
    $existingCodelistTitlesandIDs = [];
    $title = strtolower($form_state->getValue('title')[0]['value']);
    
    /*
     * einfacher wäre den Query zu erweitern
     */
    $nids = \Drupal::entityQuery('node')
            ->condition('type','registry_codelist')
            ->execute();
    $nodes =  \Drupal\node\Entity\Node::loadMultiple($nids);
    
    foreach ($nodes as $node) {
      if($node->id() != $id) {
        array_push($existingCodelistTitlesandIDs,array($node->id(),strtolower($node->getTitle())));
      }
    }
    
    
    /*
     * einfacher wäre den Query zu erweitern
     */
    $nids = \Drupal::entityQuery('node')
            ->condition('type','file_codelist')
            ->execute();
    $nodes =  \Drupal\node\Entity\Node::loadMultiple($nids);
    
    foreach ($nodes as $node) {
      if($node->id() != $id) {
        array_push($codelistTitles,strtolower($node->getTitle()));
      };
    }

    foreach ($existingCodelistTitlesandIDs as $item) {
      if($item[1] == $title) {
        $link = \Drupal\Core\Link::fromTextAndUrl($title, \Drupal\Core\Url::fromUri("internal:/node/".$item[0]))->toString();
        $form_state->setErrorByName('title', t('That code list exists. @link', array('@link' => $link)));
      }
    }
  }
}
